
<CsoundSynthesizer>
<CsOptions>
; Select audio/midi flags here according to platform
; Audio out   Audio in    No messages
;-odac           -iadc     -d     ;;;RT audio I/O

csound -s -d -+rtaudio=ALSA -odevaudio -b1024 -B16384  
</CsOptions>
<CsInstruments>
;portamento.orc 
; p7 is the amp of the next note, for us to ramp towards 
; p8 is amp of previous note, to ramp from. 
; p9 is the peak amp (expression) 
sr=44100 
kr = 1470 
ksmps=30 
nchnls=1 

instr 1 
idur = abs(p3) 
kpch = p5 
ipramp = 0.1 
i1   = -1                   ; phase for tied note 
iamp = p4                   ; tied note starts at score amp 
ir       tival 
         tigoto start 
         i1 = 0                ; first note, reset phase 
         iamp = 0              ; set start amp 
start: 
;base amplitude ramp from previous note to next note 
amp      linseg  iamp,0.05,p4,idur-0.1,p4,0.05,p7 
; skip pitch ramp generation if not needed 
         if ir==0 || p6==p5 kgoto slur 
kpchramp linseg p6,ipramp,p5,idur-ipramp,p5 
kpch =   kpchramp 
slur: 
aslur    linseg 0,idur/2,p8,idur/2,0    ; expression envelope 
aamp =  amp + aslur 
asig     oscili aamp,kpch,1,i1 
         out asig 
endin 



</CsInstruments>
<CsScore>

f1 0 1024 10 1 
; p8 sets size of expression swell (additive), 
; p4 sets base amp for note 
; use + notation to ensure notes connect cleanly as monophonic 
;1      2     3       4     5     6     7         8 
;No.  start  dur  base-amp pch   ppch nextamp  expramp 
i1      0    -1     5000    333   333  np4     10000 
i1      +    -2     2000    523   pp5  np4      3000 
i1      +    -1    11000    417   pp5  np4      4000 
i1      +     2     2000    465   pp5  0       10000 
; second legato voice at the octave, using fractional i1 notation 
i1.1    0    -1     5000    666   333  np4     10000 
i1.1    +    -2     2000   1046   pp5  np4      3000 
i1.1    +    -1    11000    834   pp5  np4      4000 
i1.1    +     2     2000    930   pp5  0       10000 
e 

</CsScore>
</CsoundSynthesizer>
